Better PDF Plugin - Insert, scale, rotate and cut-out pdf pages into your notes

Goal of this Plugin in to implement a native PDF handling workflow in Obsidian

Features

  • Insert a single PDF Page inside Note
  • Insert a List of Pages into Obsidian Note
  • Hyperlink to PDF
  • Scale the size of PDF Pages to fit Note layout
  • Page Rotation support
  • Cutout support
  • Internal Link support

Demo

Download at: https://github.com/MSzturc/obsidian-better-pdf-plugin

16 Likes

can’t search this plugin in community plugins.

This is a great plug-in !! I downloaded it from your Github page and installed it, but trying to enable it in Obs pops up a message “Failed to load”. That happened to me yesterday too with another plug-in.

So, please put it in the Community plug-ins, like @Steve_yang indicated.

Today i’ve added the first public version on github. To try it out drop the extracted archive into the plugins folder inside your vault. I will add it to the community plugins as soon as i’ve a proper error handling in it.

4 Likes

I did that and get a pop-up saying “Failed to load”.

Have you submitted a Pull Request? akaalias says in the 4th paragraph here his PR is the only one.

PR is submitted.

2 Likes

Version 1.1. is out.

It’s now possible to use internal links as url.

“url” : [[MyDocument.pdf]]

2 Likes

The PR is accepted. Better PDF plugin is now part of the community plugins

8 Likes

@MSzturc: thank you.

First of all, thank you very much for your great work. Your plugin is the reason why I was able to migrate my workflow from Denonthink and Craft to Obsidian.

What I noticed is that the documents linked by Better-PDF-Plugin are not displayed as linked mentions. Can you check whether you can get backlinks to be displayed?

1 Like

I also noticed that problem you describe. The supposed bug is nothing i could resolve in my plugin. Currently Obsidian is not able to support links from code blocks. I opened a feature request, but it was rejected with the reason that an API would be provided in the future which would allow developers to manipulate nodes in the graph.

1 Like

Ahh okay I see, thank you very much for your quick reply.

Another point that struck me is that as soon as I swipe the mouse over an embedded PDF, a popover opens. It hinders me more than it is of any use to me, especially since you can switch to the PDF document as soon as you click on it if you need it.

Why did you implement the behavior like this?

I am also aware of the problem.

Currently, you can click on a PDF document embedded by better-pdf-plugin and you will land in the PDF on the page that was embedded. For this workflow it is necessary that the embedded element has the class internal-link otherwise obsidian is not able to detect the link itself.

This is where Page Preview comes in. It creates the popover for all classes of the internal-link type, which means as long as theres no possibility to tell obsidian that’s a link that should not create a page preview you have to live with it or deactivate the page preview plugin as workaround.

I also created a feature request for it. That introduces a way to address internal links without preview.

1 Like

Thank you for your detailed answer and for your effort spent with the plugin.

Do you have an idea which features you will implement next?

Well, for me this plugin was needed to be able to migrate my old knowledge management system to my new philosophy therefore it always supports all features i need for my workflow. For me it will be never features complete but always good enough. But this doesnt mean that im not open to Feature Requests. I would like to know how you all are using better-pdf-plugin and what your workflow is, maybe something is missing that i currently dont see. Feel free to post Feature Requests.

Updated to version 1.2.0.

Obsidian changed with 0.10.12 the handling of PDF Markdown Processors which causes the issue that pdf pages wont be rendered after update.

1 Like

Hello @MSzturc , is this linked to this error I get with Obsidian 11.0?
UnknownErrorException: The API version "2.6.347" does not match the Worker version "2.5.207".

Hi @cmjn it looks like that another Version of PDF.js is part of your Obsidian. Im not an insider, so i haven’t access to this build currently. I will test it as soon as Obsidian 11 got released

1 Like

Hi yes thank you for pointing me in the right direction!
I’ve disabled all other plugins and it works now. I just have to find which one conflicted with yours.
Sorry for the inconvenience!